function Enumerable3(value: boolean) {
    return function (target: any, propertyKey: string, descriptor: PropertyDescriptor) {
        descriptor.enumerable = value;
    }
}

class Car3 {
    @Enumerable3(true)
    run() {
        console.log("inside run method...");
    }
}

console.log("-- creating instance --");
let car3 = new Car3();
console.log("-- looping --");
for (let key in car3) {
    console.log("key: " + key);
}